VERSION 5.00
Object = "{0E59F1D2-1FBE-11D0-8FF2-00A0D10038BC}#1.0#0"; "msscript.ocx"
Begin VB.Form Form1 
   Caption         =   "Numerical Integration (Single variable function)"
   ClientHeight    =   2370
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4710
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2370
   ScaleWidth      =   4710
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtRESULT 
      Appearance      =   0  'Flat
      BackColor       =   &H0080FFFF&
      Height          =   285
      Left            =   2910
      TabIndex        =   8
      Top             =   1890
      Width           =   1515
   End
   Begin VB.OptionButton optSIMPSONS 
      Caption         =   "Simpson's"
      Height          =   225
      Left            =   1140
      TabIndex        =   3
      Top             =   960
      Width           =   1065
   End
   Begin VB.OptionButton optTRAPEZOIDAL 
      Caption         =   "Trapezoidal"
      Height          =   225
      Left            =   1140
      TabIndex        =   2
      Top             =   720
      Width           =   1185
   End
   Begin VB.OptionButton optMIDPOINT 
      Caption         =   "Midpoint"
      Height          =   225
      Left            =   1140
      TabIndex        =   1
      Top             =   480
      Value           =   -1  'True
      Width           =   945
   End
   Begin VB.TextBox Text7 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2250
      TabIndex        =   0
      Text            =   "2*x^3+3*x^2+4*x+1"
      Top             =   60
      Width           =   2175
   End
   Begin VB.CommandButton cmdCALCULATE 
      Caption         =   "Calculate"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   161
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   300
      TabIndex        =   7
      Top             =   1860
      Width           =   1395
   End
   Begin VB.TextBox txtN 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   3870
      TabIndex        =   6
      Text            =   "10"
      Top             =   1290
      Width           =   555
   End
   Begin VB.TextBox txtXN 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   3570
      TabIndex        =   5
      Text            =   "5"
      Top             =   870
      Width           =   855
   End
   Begin VB.TextBox txtX0 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   3570
      TabIndex        =   4
      Text            =   "0"
      Top             =   480
      Width           =   855
   End
   Begin MSScriptControlCtl.ScriptControl ScriptControl1 
      Left            =   210
      Top             =   720
      _ExtentX        =   1005
      _ExtentY        =   1005
      AllowUI         =   -1  'True
   End
   Begin VB.Label Label3 
      Caption         =   "Result ="
      Height          =   195
      Left            =   2250
      TabIndex        =   14
      Top             =   1920
      Width           =   705
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Number of subintervals N ="
      Height          =   195
      Left            =   1770
      TabIndex        =   13
      Top             =   1320
      Width           =   2025
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "End xn ="
      Height          =   195
      Left            =   2730
      TabIndex        =   12
      Top             =   900
      Width           =   765
   End
   Begin VB.Label lblRULE 
      Caption         =   "Using rule:"
      Height          =   195
      Left            =   270
      TabIndex        =   11
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label lblFUNCTION 
      Caption         =   "Function to integrate: f(x) ="
      Height          =   195
      Left            =   270
      TabIndex        =   10
      Top             =   90
      Width           =   2085
   End
   Begin VB.Label lblX0 
      Alignment       =   1  'Right Justify
      Caption         =   "Start x0 ="
      Height          =   195
      Left            =   2730
      TabIndex        =   9
      Top             =   540
      Width           =   765
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Numerical Integration (Single variable function)
'------------------------------------------------
'This is a program that calculates the definite integral of a single variable function f(x) using numerical
'methods: The Trapezoidal method, the Midpoint method and the Simpson's method. The program uses the
'MS Scriptcontrol for evaluating the values of Function f(x).
'Add Component: Microsoft script control 1.0 (msscript.ocx)

'Written by Vagelis Plevris, Greece
'mail to: vplevris@tee.gr

Private Sub cmdCALCULATE_Click()
Dim j As Integer, N1 As Integer

x0 = Val(txtX0.Text) 'Start x0
xN = Val(txtXN.Text) 'End xN
N1 = Val(txtN.Text) 'Number of intervals
h = (xN - x0) / N1 'Distance between two points

If optMIDPOINT.Value = True Then
    'Midpoint Rule:
    'Integration, [x0->xN] f(x)dx =
    '(xN-x0)/N * Sum[j=1 -> n](f( (x[j-1]+x[j])/2 ))
    Int1 = (xN - x0) / N1
    Sum1 = 0 'Set the Sum[j=1 -> n](f( (x[j-1]+x[j])/2 )) to zero
    For j = 1 To N1
        xj = x0 + j * h 'Calculate xj
        xj_1 = x0 + (j - 1) * h 'Calculate x[j-1]
        xm = (xj_1 + xj) / 2 'Calculate (x[j-1]+x[j])/2
        Sum1 = Sum1 + Func_f_x(xm) 'Sum[j=1 -> n](f( (x[j-1]+x[j])/2 ))
    Next j
    'Write the result to textbox
    txtRESULT.Text = Int1 * Sum1
End If

If optTRAPEZOIDAL.Value = True Then
    'Trapezoidal Rule:
    'Integration, [x0->xN] f(x)dx =
    'Sum[j=1 -> n]( (h/2)*( f(x[j-1]) + f(x[j]) ) )
    '= h*( f([x0])+f([xN]))/2  + Sum[j=1 -> n-1](f(x[j]) )
    Int1 = (Func_f_x(x0) + Func_f_x(xN)) / 2 '=f([x0])+f([xN]))/2
    Sum1 = 0 'Set the Sum[j=1 -> n-1](f(x[j]) to zero
    For j = 1 To N1 - 1
        xj = x0 + j * h 'Calculate xj
        Sum1 = Sum1 + Func_f_x(xj)
    Next j
    'Write the result to textbox
    txtRESULT.Text = h * (Int1 + Sum1)
    Exit Sub
End If

If optSIMPSONS.Value = True Then
    'Simpson's Rule requirement: That N1 be even
    If N1 Mod 2 = 1 Then 'N1 is odd, not even
        message$ = "Simpson's Rule requires that number of subintervals N be even."
        response = MsgBox(message$, vbExclamation)
        Exit Sub
    End If
    'Simpson's Rule:
    'Integration, [x0->xN] f(x)dx =
    'h/3 * ( f(x0)+4*f(x[N-1])+f(xN) + 2 * Sum[j=1 -> (N/2)-1](2*f(x[2j-1]+f(x[2j])) )
    xN_1 = x0 + (N1 - 1) * h 'Calculate x[N-1]
    Int1 = Func_f_x(x0) + 4 * Func_f_x(xN_1) + Func_f_x(xN) 'Calculate f(x0)+4*f(x[N-1])+f(xN)
    Sum1 = 0 'Set the Sum[j=1 -> (N/2)-1](2*f(x[2j-1]+f(x[2j]) to zero
    For j = 1 To (N1 / 2 - 1)
        x2j_1 = x0 + (2 * j - 1) * h 'Calculate x[2j-1]
        x2j = x0 + (2 * j) * h  'Calculate x[2j]
        Sum1 = Sum1 + 2 * Func_f_x(x2j_1) + Func_f_x(x2j)
    Next j
    'Write the result to textbox
    txtRESULT.Text = h / 3 * (Int1 + 2 * Sum1)
    Exit Sub
End If

End Sub


Function Func_f_x(X1)
    'Function f(x) to integrate
    ScriptControl1.Reset 'Reset the MS Scriptcontrol
    ScriptControl1.ExecuteStatement ("x = " & X1) 'Execute statement for x variable = X1
    Func_f_x = ScriptControl1.Eval(Trim(Text7.Text)) 'Evaluate it
End Function

